#Compile Exe "gbchangepsw.exe"
#Dim All
'#Debug Error On
'#Debug Display On

%UNICODE = 1
#Include "win32api.inc"

Function PBMain () As Long
   Local lRslt As Long, MD5 As WStringZ * 33, PSW As WStringZ * 11, AllDomain As WStringZ * 2, TimeRemaining As WStringZ * 6

   PSW           = Command$(1)
   MD5           = Command$(2)
   AllDomain     = Command$(3)
   TimeRemaining = Command$(4)

   If Len(PSW) And Len(MD5) And Len(AllDomain) And Len(TimeRemaining) Then
      PSW = PSW + Space$(10-Len(PSW))
      lRslt = ReplaceStringToResource ("gbchildsafe.exe", 997,  2048, TimeRemaining)
      lRslt = ReplaceStringToResource ("gbchildsafe.exe", 998,  2048, AllDomain)
      lRslt = ReplaceStringToResource ("gbchildsafe.exe", 999,  2048, MD5)
      lRslt = ReplaceStringToResource ("gbchildsafe.exe", 1000, 2048, PSW)
   End If
   If Len(Command$(5)) Then
      lRslt = Shell("gbchildsafe.exe")
   End If
End Function

Function ReplaceStringToResource(lpFileName As WStringZ, ByVal ResID As Dword, ByVal wLangID As Word, sRes As WStringZ) As Long
 Local lpwNewBuffer, lpwTmpNew, lpwOldBuffer, lpwTmpOld, lpwStr As Word Ptr
 Local hModule, hResInfo, hUpdateRes, dwNewResSize, dwOldResSize, dwResID As Dword
 Local wStrLen, wStrIndex, wLen, Index, x As Word
 Local sBuffer, sUnicode As String

 Function = %TRUE

  wStrLen   = lstrlenW (ByVal VarPtr(sRes))' get lenght of unicode string in characters(not bytes)
  lpwStr    = VarPtr(sRes)                 ' get start address of Unicode string
  dwResID   = ResID : Shift Right dwResID, 4 : Incr dwResID ' Get SectionID
  wStrIndex = (ResID And &H000f??) ' Calculate index inside section .One STRINGTABLE section can contain 1-16 string
  hModule   = LoadLibrary(lpFileName)
  hResInfo  = FindResource(hModule, ByVal dwResID, ByVal %RT_STRING)

    If hResInfo Then                                          ' Resource section (1section=16 string) found
       dwOldResSize = SizeofResource(hModule, hResInfo)       ' size in bytes
       dwNewResSize = dwOldResSize + SizeOf(wLen) + wStrLen*2 ' Calculate estimated size of new structure.
       sBuffer=Repeat$(dwNewResSize,Chr$(0))                  ' allocate zero-filled buffer
       '
       lpwNewBuffer=StrPtr(sBuffer)
       lpwTmpNew=lpwNewBuffer
       '
       lpwOldBuffer= LockResource(LoadResource(hModule, hResInfo)) ' refer to old Resource as word ptr
       lpwTmpOld = lpwOldBuffer
       '
       For Index=0 To &H0F?           '-- fill String resource structure
           wLen = @lpwTmpOld
           If Index = wStrIndex Then  'ID of added string. New String will overwrite(Replace) existing
               @lpwTmpNew = wStrLen
               Incr lpwTmpNew
               x=0
               While x<wStrLen
                   @lpwTmpNew=@lpwStr[x]
                   Incr lpwTmpNew  : Incr x
               Wend
               lpwTmpOld = lpwTmpOld + wLen*2 : Incr lpwTmpOld
           Else                   '-- copy existing data from loaded file to our new structure
               @lpwTmpNew = wLen
               Incr lpwTmpNew : Incr lpwTmpOld
               x=wLen
               While x
                  @lpwTmpNew=@lpwTmpOld
                  Incr lpwTmpNew : Incr lpwTmpOld
                  Decr x
               Wend
           End If
       Next
       dwNewResSize = lpwTmpNew - lpwNewBuffer  ' get size of new buffer-structure
    End If
    If FreeLibrary(hModule) = 0 Then Function = %FALSE

    hUpdateRes = BeginUpdateResource(lpFileName, %FALSE)
    If hUpdateRes = 0 Then
        MsgBox "err BeginUpdateResource"
        Function = %FALSE
        Exit Function
    End If

    If UpdateResource(hUpdateRes, ByVal %RT_STRING, ByVal dwResID, ByVal wLangID, ByVal lpwNewBuffer, ByVal dwNewResSize)=0 Then
        MsgBox "err UpdateResource"
        Function = %FALSE
    End If

    If EndUpdateResource(hUpdateRes, %FALSE)=0 Then
        MsgBox "err EndUpdateResource"  +Str$(ResID)
        Function = %FALSE
    End If

End Function
